Imports System
Imports System.IO
Imports System.Text
Imports System.Net
Imports System.Collections

Imports WebImageLib

Public Class GoogleImage
	Implements IWebImage

	Shared sjisEnc As Encoding = Encoding.GetEncoding("Shift_JIS")

	Dim _currentPage As Integer
	Dim _hasNext As Boolean

	' filter=0tȂƁAQy[WڂłʂɂȂ
	Dim url As String = "http://images.google.co.jp/images?hl=ja&q={0}&start={1}&filter=0&safe=off"

	Sub New()
		Reset()
	End Sub

	Function readPage(ByVal u As String) As String
		Dim html As String = ""
		Dim wc As WebClient = Nothing
		Dim st As Stream = Nothing
		Dim sr As StreamReader = Nothing

		Try
			wc = New WebClient
			st = wc.OpenRead(u)
			sr = New StreamReader(st, sjisEnc)
			html = sr.ReadToEnd()
		Finally
			If Not sr Is Nothing Then
				sr.Close()
			End If
			If Not st Is Nothing Then
				st.Close()
			End If
			If Not wc Is Nothing Then
				wc.Dispose()
			End If
		End Try
		Return html
	End Function

	Public ReadOnly Property CurrentPage() As Integer Implements WebImageLib.IWebImage.CurrentPage
		Get
			Return _currentPage + 1
		End Get
	End Property

	Public Function GetImages(ByVal query As String) As WebImageLib.WebImage() Implements WebImageLib.IWebImage.GetImages
		Dim images As New ArrayList
		If query <> "" Then
			Dim html As String = readPage( _
			 String.Format(url, System.Web.HttpUtility.UrlEncode(query, sjisEnc), _currentPage * 20))
			Dim src As String() = html.Split(" ")

			' srcz̓e
			' href=/imgres?imgurl=http://www.charlespetzold.com/key/keycs.jpg&imgrefurl=http://www.charlespetzold.com/key/&h=475&w=389&sz=25&tbnid=sDYnpda4B2EJ:&tbnh=126&tbnw=103&hl=ja&start=3&prev=/images%3Fq%3Dc%2523%26hl%3Dja%26lr%3D%26sa%3DG><img
			' src=/images?q=tbn:sDYnpda4B2EJ:www.charlespetzold.com/key/keycs.jpg
			For i As Integer = 0 To src.Length - 1
				If i + 1 < src.Length AndAlso src(i).StartsWith("href=/imgres?") = True AndAlso src(i + 1).StartsWith("src=/images?") = True Then
					Dim small As String = "http://www.google.co.jp" & src(i + 1).Substring(4)
					Dim tmp As String() = src(i).Split("&")

					' tmpz̓e						
					' href=/imgres?imgurl=http://www.charlespetzold.com/key/keycs.jpg
					' imgrefurl=http://www.charlespetzold.com/key/
					' h=475
					' w=389 EEE
					Dim large As String = tmp(0).Substring(20)
					Dim page As String = tmp(1).Substring(10)

					images.Add(New WebImage(small, large, page))
				End If
			Next
			' uցṽNEeLXg`FbN
			If html.IndexOf("<span class=b><b></b></span>") = -1 Then
				_hasNext = False
			Else
				_hasNext = True
			End If
		End If
		Return CType(images.ToArray(GetType(WebImage)), WebImage())		  ' zɕϊ
	End Function

	Public Function MoveNext() As Boolean Implements WebImageLib.IWebImage.MoveNext
		If _hasNext Then
			_currentPage = _currentPage + 1
		End If
		Return _hasNext
	End Function

	Public ReadOnly Property Name() As String Implements WebImageLib.IWebImage.Name
		Get
			Return "Google"
		End Get
	End Property

	Public Sub Reset() Implements WebImageLib.IWebImage.Reset
		_hasNext = False
		_currentPage = 0
	End Sub
End Class

Public Class GoogleTest
	Shared Sub Main()
		Dim query As String = "c#"
		Dim google As New GoogleImage

		Do
			For Each wi As WebImage In google.GetImages(query)
				Console.WriteLine(google.CurrentPage)
				Console.WriteLine(wi.SmallImageURL)
				Console.WriteLine(wi.LargeImageURL)
				Console.WriteLine(wi.DetailPageURL)
			Next
		Loop Until google.MoveNext() = False
	End Sub
End Class
